#include <iostream>
#include <vector>
#include "histogram.h"
#include "svg.h"
#include "text.h"
//#include "mycheck.h"

using namespace std;

//const size_t SCREEN_WIDTH = 80;
//const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

struct Input
{
    vector<double> numbers;
    size_t bin_count{};
    size_t IMAGE_WIDTH{};
    
};

Input 
input_data(istream& in)
{

    size_t number_count, bin_count, IMAGE_WIDTH;

    cerr << "Enter number count: ";
    in >> number_count;

    Input n;

    
    cerr << " Input width of image, > 70 but not >800 : ";
    in >> n.IMAGE_WIDTH;
    if(n.IMAGE_WIDTH < 70 || n.IMAGE_WIDTH > 800 ) {
        while(n.IMAGE_WIDTH < 70 || n.IMAGE_WIDTH > 800) {
            cerr << " Input width of image, >70 but not >800 : ";
            in >> n.IMAGE_WIDTH;
        }
    }
  

    //size_t number_count = in.number_counts;

    n.numbers.resize( number_count );
    cerr << "Enter numbers: ";
    // vector<double> numbers(number_count);

    for (size_t i = 0; i < number_count; i++)
    {
        in >> n.numbers[i];
    }

    cerr << "Count of baskets: ";
    in >> n.bin_count;

    return n;
}

int main()
{   
    
    auto n = input_data(cin);
    auto bins = make_histogram( n.numbers, n.bin_count );
    //int chek_block_width(in.IMAGE_WIDTH);
    //chek_block_width(in.IMAGE_WIDTH, in.number_count);
    //if (chek_block_width==1)
    show_histogram_svg( bins,n.IMAGE_WIDTH );
    //if(chek_block_width==0) return 0;
    //show_histogram_svg(bins);
  
}